package modele;

import java.awt.Font;
import java.io.File;
import java.io.FileOutputStream;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Observable;
import java.util.Scanner;

import javax.swing.JLabel;

public class Menu extends Observable {
	
	public boolean quit = false;

	public boolean game = false;
	
	
	public int option = 1;
	private static int limitAction = 2;
	
	
	public Menu()
	{
		this.reInitMenu();
	}
	
	public void reInitMenu()
	{
		this.quit = false;
		this.game = false;
		this.option = 1;
	}
	
	
	public void action(ActionMenu am)
	{
		switch(am)
		{
			case descendre: 
				this.option += 1;
				if(this.option>limitAction)
					this.option = 1;
				break;
			case monter: 
				this.option -= 1;
				if(this.option==0)
					this.option = limitAction;
				break;
			case entrer: 
				if(option == 1)
					this.game = true;
				else if(option == 2)
					this.quit = true;
		}
	}
	
	public void run()
	{
		try {
			Thread.sleep(500);
		} catch (InterruptedException e) {
			return;
		}
        setChanged();
        notifyObservers();
	}
	
	public int getNbOption()
	{
		return limitAction;
	}
	
	public HashMap<Integer,String> getScoreS()
	{
		HashMap<Integer,String> listScore = new HashMap<Integer,String>();
		
		String nmF="scores.sc";
		try(Scanner scanner=new Scanner(new File(nmF))){
		    while(scanner.hasNextLine())  //Lit le fichier ligne par ligne
		    {
		        Scanner line=new Scanner(scanner.nextLine());
                line.useDelimiter("-");
		        String nm=line.next();
		        int sc=line.nextInt();
		        
		        listScore.put(sc, nm);
		        
		        line.close();
		    }
		    scanner.close();
		    
		}catch (IOException exception) {
		    System.out.println("Erreur impossible de lire le fichier");
		}

		
		return listScore;
	}
	
	public void saveScores(HashMap<Integer,String> listScore)
	{
		String nmF="scores.sc";
        try {
    		FileOutputStream file =  new FileOutputStream(new File( nmF)); 
            ArrayList<Integer> lstScore = new ArrayList<Integer>(listScore.keySet());
            lstScore.sort(null);
            for(int i = lstScore.size()-1; i>=0; i-- )
            {	
    
            	file.write((listScore.get(lstScore.get(i))+"-"+String.valueOf(lstScore.get(i))+"\n").getBytes());
            }
            file.close();
            
        } catch (Exception e) {
            System.out.println("Impossible de creer le fichier");
        }
    }

}
